Meet in the middle - GeeksforGeeks
Given a set of n integers where n <= 40. Each of them is at most 1012, determine the maximum sum subset having sum less than or equal S(S1018)
https://www.quora.com/What-is-meet-in-the-middle-algorithm-w-r-t-competitive-programming
Given a set of n integers where n <= 40. Each of them is at most 1012, determine the maximum sum subset having sum less than or equal S(S1018)
Input : set[] = {45, 34, 4, 12, 5, 2} and S = 42 Output : 41 Maximum possible subset sum is 41 which can be obtained by summing 34, 5 and 2.
A Brute Force approach to solve this problem would be find all possible subset sums of N integers and check if it is less than or equal S and keep track of such a subset with maximum sum. The time complexity using this approach would be O(2n) and n is at most 40. 240 will be quite large and hence we need to find more optimal approach.
Meet in the middle is a search technique which is used when the input is small but not as small that brute force can be used. Like divide and conquer it splits the problem into two, solves them individually and then merge them. But we can’t apply meet in the middle like divide and conquer because we don’t have the same structure as the original problem.
- Split the set of integers into 2 subsets say A and B. A having first n/2 integers and B having rest.
- Find all possible subset sums of integers in set A and store in an array X. Similarly calculate all possible subset sums of integers in set B and store in array Y. Hence, Size of each of the array X and Y will be at most 2n/2.
- Now merge these 2 subproblems. Find combinations from array X and Y such that their sum is less than or equal to S.
- One way to do that is simply iterate over all elements of array Y for each element of array X to check the existence of such a combination. This will take O( (2n/2)2) which is equivalent to O(2n).
- To make it less complex, first sort array Y and then iterate over each element of X and for each element x in X use binary search to find maximum element y in Y such that x + y <= S.
- Binary search here helps in reducing complexity from 2nto 2n/2log(2n/2)which is equivalent to 2n/2n.
- Thus our final running time is O(2n/2n).
ll X[2000005],Y[2000005];
// Find all possible sum of elements of a[] and store
// in x[]
void
calcsubarray(ll a[], ll x[],
int
n,
int
c)
{
for
(
int
i=0; i<(1<<n); i++)
{
ll s = 0;
for
(
int
j=0; j<n; j++)
if
(i & (1<<j))
s += a[j+c];
x[i] = s;
}
}
// Returns the maximum possible sum less or equal to S
ll solveSubsetSum(ll a[],
int
n, ll S)
{
// Compute all subset sums of first and second
// halves
calcsubarray(a, X, n/2, 0);
calcsubarray(a, Y, n-n/2, n/2);
int
size_X = 1<<(n/2);
int
size_Y = 1<<(n-n/2);
// Sort Y (we need to do doing binary search in it)
sort(Y, Y+size_Y);
// To keep track of the maximum sum of a subset
// such that the maximum sum is less than S
ll max = 0;
// Traverse all elements of X and do Binary Search
// for a pair in Y with maximum sum less than S.
for
(
int
i=0; i<size_X; i++)
{
if
(X[i] <= S)
{
// lower_bound() returns the first address
// which has value greater than or equal to
// S-X[i].
int
p = lower_bound(Y, Y+size_Y, S-X[i]) - Y;
// If S-X[i] was not in array Y then decrease
// p by 1
if
(p == size_Y || Y[p] != (S-X[i]))
p--;
if
((Y[p]+X[i]) > max)
max = Y[p]+X[i];
}
}
return
max;
}
Meet in the middle is a search technique used when the input size is small but not small enough to use direct brute force.
A famous example
Knapsack
Given a set of integers each of them is at most determine the largest sum subset having sum less than or equal ()
Given a set of integers each of them is at most determine the largest sum subset having sum less than or equal ()
If was 20 we could've tried all possible subsets, but now is 40 and seems too much.
Lets split the numbers into two sets , first having the first numbers, second having the rest, now each of the two sets have at most 20 numbers.
Lets calculate subset sums for and store them in an array , and calculate subset sums for and store them in an array .
Lets calculate subset sums for and store them in an array , and calculate subset sums for and store them in an array .
Now we sort the array , and iterate over the elements of , for each element , we can use binary search to find the largest element in such that .
Some of my favorite problems using meet in the middle -
- TreeUnion Div2 - Graph Easy
- RandomShuffle - Easy
- Knapsack Problem - Knapsack Easy
- ACM-ICPC Amritapuri 2011 - Problem C - Robbing Gringotts - Bipartite Easy
- SumThemAll - Math + Greedy
- SplitAndMerge Game
- Telephone Numbers
- Problemset - Codeforces